# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.OpenHouse do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :AppointmentRequiredYN,
    :OpenHouseDate,
    :ListingKeyNumeric,
    :OpenHouseKeyNumeric,
    :ShowingAgentKeyNumeric,
    :ListingId,
    :ListingKey,
    :OpenHouseId,
    :OpenHouseKey,
    :OpenHouseRemarks,
    :OriginatingSystemID,
    :OriginatingSystemKey,
    :OriginatingSystemName,
    :Refreshments,
    :ShowingAgentFirstName,
    :ShowingAgentKey,
    :ShowingAgentLastName,
    :ShowingAgentMlsID,
    :SourceSystemID,
    :SourceSystemKey,
    :SourceSystemName,
    :OpenHouseAttendedBy,
    :OpenHouseStatus,
    :OpenHouseType,
    :ModificationTimestamp,
    :OpenHouseEndTime,
    :OpenHouseStartTime,
    :OriginalEntryTimestamp,
    :ShowingAgent,
    :OriginatingSystem,
    :SourceSystem,
    :Property
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :AppointmentRequiredYN => boolean() | nil,
    :OpenHouseDate => Date.t | nil,
    :ListingKeyNumeric => float() | nil,
    :OpenHouseKeyNumeric => float() | nil,
    :ShowingAgentKeyNumeric => float() | nil,
    :ListingId => String.t | nil,
    :ListingKey => String.t | nil,
    :OpenHouseId => String.t | nil,
    :OpenHouseKey => String.t | nil,
    :OpenHouseRemarks => String.t | nil,
    :OriginatingSystemID => float() | nil,
    :OriginatingSystemKey => String.t | nil,
    :OriginatingSystemName => String.t | nil,
    :Refreshments => String.t | nil,
    :ShowingAgentFirstName => String.t | nil,
    :ShowingAgentKey => String.t | nil,
    :ShowingAgentLastName => String.t | nil,
    :ShowingAgentMlsID => String.t | nil,
    :SourceSystemID => float() | nil,
    :SourceSystemKey => String.t | nil,
    :SourceSystemName => String.t | nil,
    :OpenHouseAttendedBy => String.t | nil,
    :OpenHouseStatus => String.t | nil,
    :OpenHouseType => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OpenHouseEndTime => Date.t | nil,
    :OpenHouseStartTime => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :ShowingAgent => FoyerAPI.Model.Member.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :Property => FoyerAPI.Model.Property.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.OpenHouse do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:OpenHouseDate, :date, nil, options)
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OpenHouseEndTime, :date, nil, options)
    |> deserialize(:OpenHouseStartTime, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:ShowingAgent, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:Property, :struct, FoyerAPI.Model.Property, options)
  end
end

